bool
PlayState::UpdateState()
{
	// check the current CD play state and force a notification to
	// be sent if it changed from last time
	
	scsi_position pos;
	status_t media_status = B_DEV_NO_MEDIA;
	ioctl(devicefd, B_GET_MEDIA_STATUS, &media_status, sizeof(media_status));
	
	if (media_status != B_OK)
		; // no media

	status_t result = ioctl(devicefd, B_SCSI_GET_POSITION, &pos);

	if (result != B_OK)
		; // no media
		
	else if ((!pos.position[1]) || (pos.position[1] >= 0x13) 
		|| ((pos.position[1] == 0x12) && (!pos.position[6])))
		; // stopped
		
	else if (pos.position[1] == 0x11)
		; // playing
	else
		; // paused
}

