#ifndef _GENERICSETTINGS_H
#define _GENERICSETTINGS_H

#include <Message.h>
#include <FindDirectory.h> 
#include <String.h>
#include <Volume.h>

class GenericSettings : public BMessage
{
public:
					GenericSettings		();
					GenericSettings		(BMessage a_message);
					~GenericSettings	();
	
	status_t		SetTo		(const char * a_settings_filename, 
								 BVolume * a_volume				=	NULL,
								 directory_which a_base_dir		=	B_USER_SETTINGS_DIRECTORY,
								 const char * a_relative_path	=	NULL);

	status_t		InitCheck	(void);
	
	status_t		ReadSettings		();
	status_t		WriteSettings		();
			
private:

	status_t		GetSettingsFile		(BFile * a_settings_file, uint32 a_openmode);

	BVolume				m_volume;
	directory_which		m_base_dir;
	BString				m_relative_path;
	BString				m_settings_filename;

};

#endif

