#include <stdio.h>

#include <Deskbar.h>
#include <Entry.h>
#include <Roster.h>
#include <Alert.h>

#include "MiniCDDefines.h"
#include "MiniCDApp.h"
#include "MiniCDReplicant.h"

MiniCD::MiniCD()
	: BApplication(MINICD_APP_SIGNATURE)
{
}

void
MiniCD::ReadyToRun(void)
{
	BDeskbar  deskbar;
	status_t  status  =  B_OK;

	if (! deskbar.HasItem(MINICD_REPLICANT_VIEW_NAME))
	{
		entry_ref	ref;
		be_roster->FindApp(MINICD_APP_SIGNATURE, & ref);
		status  =  deskbar.AddItem(&ref);

		if (status != B_OK)
			printf("Error adding replicant: %s\n", strerror(status));
	}
	else
	{
		BAlert * alert = new BAlert(MINICD_APP_NAME, MINICD_APP_NAME " is already running.\n"
								"Look for its icon on Deskbar's icon shelf.", "Oh, right!");
		alert->Go();
	}

	PostMessage(B_QUIT_REQUESTED);
}

BView *	instantiate_deskbar_item	(void)
{
	return new DeskbarReplicant();
}
