#ifndef _MINICDLOOPER_H
#define _MINICDLOOPER_H

#include <Looper.h>
#include <VolumeRoster.h>
#include <List.h>

#include <fs_info.h>

#include "MiniCDReplicant.h"
#include "MiniCDWorker.h"
#include "MiniCDDefines.h"

class DeskbarReplicant;
class MiniCDWorker;

class MiniCDLooper : public BLooper 
{
public:
					MiniCDLooper		(DeskbarReplicant * replicant);
					~MiniCDLooper		(void);
	virtual void	MessageReceived	(BMessage* message);
	virtual bool	QuitRequested	(void);
	
	void			CheckStatus		(void);	// called by worker thread every 500000us

protected:
private:

	void		OpenWebsite			(char * a_url);
	void		AboutRequested		(void);
	
	void		LookForAlreadyMountedCD (void);
	void		HandleDeviceEvent		(BMessage * message);
	bool		IfCddaAddDeviceToList	(fs_info * fsinfo);
	status_t	InterfaceWithDevice		(fs_info * fsinfo);
	void		DoThisIfNoDevice		(void);

	void		TellViewToExpand		(void);
	void		TellViewToContract		(void);
	
	
	status_t	GetCurrentTrack		(int32 * current_track);
	status_t	GetNumOfTracks		(int32 * num_of_tracks);
	void		Pause				(void);
	void		Play				(int32 track_num = 0);
	void		PlayContinue		(void);
	void		Stop				(void);
	void		Eject				(void);
	void		SkipOneForward		(void);
	void		SkipOneBackward		(void);
	
	DeskbarReplicant	*	m_replicant_view;
	BVolumeRoster		*	m_volume_roster;

	BList	fsinfo_list;
	int		device_fd;
	
	int32	m_media_state;
	int32	m_current_track;
	int32	m_num_of_tracks;
	
	bool	m_autoplay;
	
	MiniCDWorker *	m_worker_thread;
};

#endif
