// license: public domain
// authors: jonas.sundstrom@kirilla.com

#include <Messenger.h>
#include <Window.h>
#include <Path.h>

#include "MiniCDDefines.h"
#include "MiniCDWorker.h"
#include "MiniCDLooper.h"

#include <unistd.h>
#include <errno.h>
#include <scsi.h>

#define DEBUG 0
#include <Debug.h>

MiniCDWorker::MiniCDWorker (MiniCDLooper * a_looper)
:	GenericThread(MINICD_POLLER, B_NORMAL_PRIORITY, NULL)
{
	PRINT(("MiniCDWorker()\n"));
	
	m_master  =  a_looper;
}

MiniCDWorker::~MiniCDWorker()	
{
	// delete something
}

status_t
MiniCDWorker::ThreadStartup (void)
{
	PRINT(("MiniCDWorker::ThreadStartup()\n"));

	return B_OK;
}

status_t
MiniCDWorker::ExecuteUnit (void)
{
	PRINT(("MiniCDWorker::ExecuteUnit()\n"));

	if (m_master-> Lock())
	{
		m_master-> CheckStatus();
		m_master-> Unlock();
		snooze(200000);
	}
	
	snooze(200000);

	return B_OK;
}

status_t
MiniCDWorker::ThreadShutdown (void)
{
	PRINT(("MiniCDWorker::ThreadShutdown()\n"));

	return B_OK;
}

void
MiniCDWorker::ThreadStartupFailed (status_t a_status)
{
	error_message("MiniCDWorker::ThreadStartupFailed() \n", a_status);
	Quit();
}

void
MiniCDWorker::ExecuteUnitFailed (status_t a_status)
{
	error_message("MiniCDWorker::ExecuteUnitFailed() \n", a_status);
	Quit();
}

void
MiniCDWorker::ThreadShutdownFailed (status_t a_status)
{
	error_message("MiniCDWorker::ThreadShutdownFailed() \n", a_status);
}
